var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { KeyValueType } from "./KeyValueType";
import { Meteor } from "meteor/meteor";
export var trueValues = ["ja", "yes", "wahr", "true", "1", "✓"];
export var falseValues = ["nein", "no", "falsch", "false", "0", "✗"];
var BooleanKeyValueType = /** @class */ (function (_super) {
    __extends(BooleanKeyValueType, _super);
    function BooleanKeyValueType() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    BooleanKeyValueType.validate = function (val) {
        if (typeof val === "boolean") {
            return val;
        }
        else {
            throw new Meteor.Error("invalid-boolean", "'" + val + "' is not a valid boolean.");
        }
    };
    BooleanKeyValueType.prototype.getSuggestions = function (prefix) {
        var substringLower = prefix.toLowerCase();
        var trueValue = trueValues.find(function (val) { return val.includes(substringLower); });
        var falseValue = falseValues.find(function (val) { return val.includes(substringLower); });
        return [
            { display: this.display(true), match: trueValue, value: trueValues[0] },
            { display: this.display(false), match: falseValue, value: falseValues[0] },
        ].filter(function (o) { return o.match !== undefined; });
    };
    BooleanKeyValueType.prototype.parseString = function (val) {
        var value = val.toLowerCase();
        if (value === "" || trueValues.includes(value)) {
            return true;
        }
        else if (falseValues.includes(value)) {
            return false;
        }
        else {
            return undefined;
        }
    };
    BooleanKeyValueType.prototype.checkValue = function (val) {
        if (typeof val === "boolean") {
            return val;
        }
        else {
            return undefined;
        }
    };
    BooleanKeyValueType.prototype.display = function (value) {
        if (value) {
            return { text: "✓" };
        }
        else {
            return { text: "✗" };
        }
    };
    BooleanKeyValueType.prototype.editText = function (value) {
        if (value) {
            return trueValues[0];
        }
        else {
            return falseValues[0];
        }
    };
    return BooleanKeyValueType;
}(KeyValueType));
export default BooleanKeyValueType;
