import { KeyValueDisplay, KeyValueSuggestion } from "./KeyValueDatatypes";
import { KeyValueEntry } from "./KeyValueEntry";
export declare abstract class KeyValueType<T> {
    private readonly _id;
    private readonly _label;
    private readonly _aliases;
    constructor(id: string, label: string, aliases?: string[]);
    get id(): string;
    get label(): string;
    get aliases(): string[];
    findAlias(substring: string): string | undefined;
    createPartialEntry(): KeyValueEntry<T>;
    tryCreatePartialEntry(key: string): KeyValueEntry<T> | undefined;
    tryCreateFullEntry(val: T | string): KeyValueEntry<T> | undefined;
    abstract getSuggestions(prefix: string, entries: Array<KeyValueEntry<any>>, defaultEntries: Array<KeyValueEntry<any>>, allowDuplicates: boolean): KeyValueSuggestion[];
    abstract parseString(val: string): T | undefined;
    abstract checkValue(val: any): T | undefined;
    abstract display(value: T): KeyValueDisplay;
    abstract editText(value: T): string;
    isEqual(entryA: KeyValueEntry<T>, entryB: KeyValueEntry<any>): boolean;
    isValueEqual(valueA?: T, valueB?: T): boolean;
}
