import { NumberDelimiters } from "../helpers/formatting";
import { CompOperator, CompOpSymbol } from "../helpers/operators";
import { KeyValueSuggestion, KeyValueTextDisplay } from "./KeyValueDatatypes";
import { KeyValueType } from "./KeyValueType";
import NumberFormat = Intl.NumberFormat;
export interface SlackNumberKeyValue {
    operator: CompOpSymbol | CompOperator;
    number: number;
}
export interface NumberKeyValue extends SlackNumberKeyValue {
    operator: CompOperator;
}
export default class NumberKeyValueType extends KeyValueType<NumberKeyValue> {
    static mongoSelectorFor(value: NumberKeyValue, numberTransform?: (n: number) => number): {
        [x: string]: number;
    };
    private _delimiters;
    private _groupsDelimiterRegex;
    set delimiters(delimiters: NumberDelimiters);
    private _numberFormatter?;
    set numberFormatter(numberFormatter: NumberFormat | undefined);
    getSuggestions(prefix: string): KeyValueSuggestion[];
    parseString(val: string): NumberKeyValue | undefined;
    checkValue(val: any): NumberKeyValue | undefined;
    display(value: SlackNumberKeyValue): KeyValueTextDisplay;
    editText(value: SlackNumberKeyValue): string;
    isValueEqual(valueA?: NumberKeyValue, valueB?: NumberKeyValue): boolean;
}
